Basic Icicle in JavaScript

Using ApexCharts with JavaScript

This Basic Icicle example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      data: [
        {
          x: 'All storage',
          children: [
            {
              x: 'Engineering',
              children: [
                {
                  x: 'Platform',
                  children: [
                    { x: 'Build', y: 210 },
                    { x: 'Runtime', y: 160 },
                    { x: 'Tooling', y: 70 },
                  ],
                },
                {
                  x: 'Product',
                  children: [
                    { x: 'Web', y: 180 },
                    { x: 'Mobile', y: 120 },
                  ],
                },
                { x: 'Data', y: 140 },
              ],
            },
            {
              x: 'Design',
              children: [
                { x: 'Research', y: 60 },
                { x: 'Brand', y: 45 },
                { x: 'Systems', y: 35 },
              ],
            },
            {
              x: 'Operations',
              children: [
                { x: 'Support', y: 90 },
                { x: 'Finance', y: 40 },
              ],
            },
          ],
        },
      ],
    },
  ],
  chart: {
    type: 'icicle',
    height: 420,
  },
  colors: ['#0EA5E9', '#14B8A6', '#F59E0B'],
  title: {
    text: 'Storage used, by department and team',
    align: 'left',
  },
  subtitle: {
    text: 'Click a band to zoom into that branch',
    align: 'left',
  },
  plotOptions: {
    icicle: {
      borderRadius: 3,
      spacing: 2,
      dataLabels: {
        showValue: true,
      },
    },
  },
  stroke: {
    width: 1,
    colors: ['#fff'],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Basic Icicle in Angular

Using ApexCharts with Angular

This Basic Icicle example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              data: [
                {
                  x: 'All storage',
                  children: [
                    {
                      x: 'Engineering',
                      children: [
                        {
                          x: 'Platform',
                          children: [
                            { x: 'Build', y: 210 },
                            { x: 'Runtime', y: 160 },
                            { x: 'Tooling', y: 70 },
                          ],
                        },
                        {
                          x: 'Product',
                          children: [
                            { x: 'Web', y: 180 },
                            { x: 'Mobile', y: 120 },
                          ],
                        },
                        { x: 'Data', y: 140 },
                      ],
                    },
                    {
                      x: 'Design',
                      children: [
                        { x: 'Research', y: 60 },
                        { x: 'Brand', y: 45 },
                        { x: 'Systems', y: 35 },
                      ],
                    },
                    {
                      x: 'Operations',
                      children: [
                        { x: 'Support', y: 90 },
                        { x: 'Finance', y: 40 },
                      ],
                    },
                  ],
                },
              ],
            },
          ],
          chart: {
            type: 'icicle',
            height: 420,
          },
          colors: ['#0EA5E9', '#14B8A6', '#F59E0B'],
          title: {
            text: 'Storage used, by department and team',
            align: 'left',
          },
          subtitle: {
            text: 'Click a band to zoom into that branch',
            align: 'left',
          },
          plotOptions: {
            icicle: {
              borderRadius: 3,
              spacing: 2,
              dataLabels: {
                showValue: true,
              },
            },
          },
          stroke: {
            width: 1,
            colors: ['#fff'],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Basic Icicle in Vue

Using ApexCharts with Vue

This Basic Icicle example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="icicle"
        height="420"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/icicle'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          data: [
            {
              x: 'All storage',
              children: [
                {
                  x: 'Engineering',
                  children: [
                    {
                      x: 'Platform',
                      children: [
                        { x: 'Build', y: 210 },
                        { x: 'Runtime', y: 160 },
                        { x: 'Tooling', y: 70 },
                      ],
                    },
                    {
                      x: 'Product',
                      children: [
                        { x: 'Web', y: 180 },
                        { x: 'Mobile', y: 120 },
                      ],
                    },
                    { x: 'Data', y: 140 },
                  ],
                },
                {
                  x: 'Design',
                  children: [
                    { x: 'Research', y: 60 },
                    { x: 'Brand', y: 45 },
                    { x: 'Systems', y: 35 },
                  ],
                },
                {
                  x: 'Operations',
                  children: [
                    { x: 'Support', y: 90 },
                    { x: 'Finance', y: 40 },
                  ],
                },
              ],
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'icicle',
          height: 420,
        },
        colors: ['#0EA5E9', '#14B8A6', '#F59E0B'],
        title: {
          text: 'Storage used, by department and team',
          align: 'left',
        },
        subtitle: {
          text: 'Click a band to zoom into that branch',
          align: 'left',
        },
        plotOptions: {
          icicle: {
            borderRadius: 3,
            spacing: 2,
            dataLabels: {
              showValue: true,
            },
          },
        },
        stroke: {
          width: 1,
          colors: ['#fff'],
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 760px;
  margin: 35px auto;
}
</style>

Basic Icicle in React

Using ApexCharts with React

This Basic Icicle example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/icicle'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        data: [
          {
            x: 'All storage',
            children: [
              {
                x: 'Engineering',
                children: [
                  {
                    x: 'Platform',
                    children: [
                      { x: 'Build', y: 210 },
                      { x: 'Runtime', y: 160 },
                      { x: 'Tooling', y: 70 },
                    ],
                  },
                  {
                    x: 'Product',
                    children: [
                      { x: 'Web', y: 180 },
                      { x: 'Mobile', y: 120 },
                    ],
                  },
                  { x: 'Data', y: 140 },
                ],
              },
              {
                x: 'Design',
                children: [
                  { x: 'Research', y: 60 },
                  { x: 'Brand', y: 45 },
                  { x: 'Systems', y: 35 },
                ],
              },
              {
                x: 'Operations',
                children: [
                  { x: 'Support', y: 90 },
                  { x: 'Finance', y: 40 },
                ],
              },
            ],
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'icicle',
        height: 420,
      },
      colors: ['#0EA5E9', '#14B8A6', '#F59E0B'],
      title: {
        text: 'Storage used, by department and team',
        align: 'left',
      },
      subtitle: {
        text: 'Click a band to zoom into that branch',
        align: 'left',
      },
      plotOptions: {
        icicle: {
          borderRadius: 3,
          spacing: 2,
          dataLabels: {
            showValue: true,
          },
        },
      },
      stroke: {
        width: 1,
        colors: ['#fff'],
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="icicle"
          height={420}
        />
      </div>
    </div>
  )
}

export default ApexChart